## openh264enc openh264enc |

## Properties

gboolean | adaptive-quantization | Read / Write
gboolean | background-detection | Read / Write
guint | bitrate | Read / Write
GstOpenh264encDeblockingModes | deblocking | Read / Write
gboolean | enable-denoise | Read / Write
gboolean | enable-frame-skip | Read / Write
guint | gop-size | Read / Write
guint | max-slice-size | Read / Write
guint | multi-thread | Read / Write
guint | num-slices | Read / Write
RC_MODES | rate-control | Read / Write
gboolean | scene-change-detection | Read / Write
GstOpenh264EncSliceModes | slice-mode | Read / Write
EUsageType | usage-type | Read / Write
GstOpenh264encComplexity | complexity | Read / Write
guint | max-bitrate | Read / Write
guint | qp-max | Read / Write
guint | qp-min | Read / Write

## Types and Values

struct | GstOpenh264Enc

## Implemented Interfaces

GstOpenh264Enc implements GstPreset.

## Description

## Synopsis

### Element Information

plugin | openh264
author | Ericsson AB, http://www.ericsson.com
class | Encoder/Video

### Element Pads

name | sink
direction | sink
presence | always
details | video/x-raw, format=(string)I420, width=(int)[ 1, 2147483647 ], height=(int)[ 1, 2147483647 ], framerate=(fraction)[ 0/1, 2147483647/1 ]

name | src
direction | source
presence | always
details | video/x-h264, stream-format=(string)byte-stream, alignment=(string)au, profile=(string)baseline

## Functions

## Types and Values

### struct GstOpenh264Enc

    struct GstOpenh264Enc {
      GstVideoEncoder base_openh264enc;
    };

## Property Details

### The `“adaptive-quantization”` property

      “adaptive-quantization”    gboolean

Adaptive quantization.

Flags: Read / Write

Default value: TRUE

### The `“background-detection”` property

      “background-detection”     gboolean

Background detection.

Flags: Read / Write

Default value: TRUE

### The `“bitrate”` property

      “bitrate”                  guint

Bitrate (in bits per second).

Flags: Read / Write

Default value: 128000

### The `“deblocking”` property

      “deblocking”               GstOpenh264encDeblockingModes

Deblocking mode.

Flags: Read / Write

Default value: Deblocking on

### The `“enable-denoise”` property

      “enable-denoise”           gboolean

Denoise control.

Flags: Read / Write

Default value: FALSE

### The `“enable-frame-skip”` property

      “enable-frame-skip”        gboolean

Skip frames to reach target bitrate.

Flags: Read / Write

Default value: FALSE

### The `“gop-size”` property

      “gop-size”                 guint

Number of frames between intra frames.

Flags: Read / Write

Default value: 90

### The `“max-slice-size”` property

      “max-slice-size”           guint

The maximum size of one slice (in bytes).

Flags: Read / Write

Default value: 1500000

### The `“multi-thread”` property

      “multi-thread”             guint

The number of threads.

Flags: Read / Write

Default value: 0

### The `“num-slices”` property

      “num-slices”               guint

The number of slices (needs slice-mode=n-slices).

Flags: Read / Write

Default value: 1

### The `“rate-control”` property

      “rate-control”             RC_MODES

Rate control mode.

Flags: Read / Write

Default value: Quality mode

### The `“scene-change-detection”` property

      “scene-change-detection”   gboolean

Scene change detection.

Flags: Read / Write

Default value: TRUE

### The `“slice-mode”` property

      “slice-mode”               GstOpenh264EncSliceModes

Slice mode.

Flags: Read / Write

Default value: Fixed number of slices

### The `“usage-type”` property

      “usage-type”               EUsageType

Type of video content.

Flags: Read / Write

Default value: video from camera

### The `“complexity”` property

      “complexity”               GstOpenh264encComplexity

Complexity.

Flags: Read / Write

Default value: Medium complexity / medium speed encoding

### The `“max-bitrate”` property

      “max-bitrate”              guint

Maximum Bitrate (in bits per second).

Flags: Read / Write

Default value: 0

### The `“qp-max”` property

      “qp-max”                   guint

Maximum quantizer.

Flags: Read / Write

Allowed values: <= 51

Default value: 51

### The `“qp-min”` property

      “qp-min”                   guint

Minimum quantizer.

Flags: Read / Write

Allowed values: <= 51

Default value: 0